<?php

/*                                                       www.zoomstats.org
   +----------------------------------------------------------------------+
   | ZoomStats  ::  Web Traffic Analyzer                                  |
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2003 ZoomStats Group                              |
   +----------------------------------------------------------------------+
   | This file is protected by General Public License (GPL)               |
   |                                                                      |
   | GPL license does not restrict you from the usage, modification and   |
   | and redistribuition of this code. It, however, requires you to       |
   | always maintain each and every copyright (c) notice untouched.       |
   |                                                                      |
   | For full license please see the file LICENSE.TXT in this             |
   | distribution. The up-to-date version of this license is also         |
   | available online at: www.zoomstats.org/license                       |
   +----------------------------------------------------------------------+

     Project Home:
   +----------------------------------------------------------------------+
     Official Site:    http://www.zoomstats.org
     Development Area: http://sf.net/projects/zoomstats
     Latest Release:   http://sf.net/project/showfiles.php?group_id=59637
     CVS Repository:   http://sf.net/cvs/?group_id=59637
     Support & Bugs:   http://sf.net/tracker/?group_id=59637

   +----------------------------------------------------------------------+
   |                       !!! BE INTERACTIVE !!!                         |
   |                                                                      |
   | Please send us your patches, improvements, bugs, requests or just    |
   | say thanks at the links above.                                       |
   +----------------------------------------------------------------------+

     File:             $RCSfile: index.php,v $
   +----------------------------------------------------------------------+
     Version:          $Revision: 1.14 $
     Last Updated:     $Date: 2003/06/27 05:17:41 $
     Last Author:      $Author: s-maxim $

     Maintainers:
   +----------------------------------------------------------------------+
     Maxim Maletsky    (s-maxim)
     maxim at php dot net     http://www.maxim.cx 

     Description:
   +----------------------------------------------------------------------+
     File to test the current functions of CVS

 */


// Prevents theoretical security risks
if(!defined('zoomstats'))
	define('zoomstats', True, True);

define('NO_AUTH', True, True);

$db_types = Array(
	 'mysql'=>'MySQL'
	,'pgsql'=>'PostgreSQL'
	,'oracle'=>'Oracle 8/9'
);

$GLOBALS['no_db']           = 
$GLOBALS['just_created_db'] = 
$installed                  = False;
$defaults                   = Array();

include '../libs/functions.php';
include '../config.php';

function db_execute($actions) {
	Global $db;
	foreach($actions as $alias=>$params) {

		if(isset($params['batch'])) {
			foreach($params['batch'] as $batch_id=>$batch_data)
				db_execute(Array($alias=>Array('desc'=>$params['desc'] . " ($batch_id)", 'data'=>$batch_data)));
			Continue;
		}
		else {

			if($params['desc']) {
				fecho ("	{$params['desc']}...\n");
				flush();
			}
		}

		// Execute query
		$db->query($alias, $params['data']);
	}
}

function fecho($str) {
	print $str;
	flush();
}

function db_form($type, $supported_types, $host, $db, $user, $pass, $prefix, $db_create, $no_db) {
	?>

	<pre><h1>
Database details</h1></pre>

	<form method="POST" action="<?php echo $_SERVER['PHP_SELF']; ?>">
		<table width="600" cellspacing=0 cellpadding=0 border=0>

			<tr>
				<td width="50%" align="right">Server:&nbsp;&nbsp;</td>
				<td width="50%" align="left" nowrap>
				<select name='type' style="width: 150">
					<?php
						foreach($supported_types as $key=>$val)
							echo "<option value='$key' " . ($type == $key? ' selected' : '') . ">$val</option>";
					?>
				</select>
				</td>
			</tr>

			<tr>
				<td width="50%" align="right">Host:&nbsp;&nbsp;</td>
				<td width="50%" align="left" nowrap><input type="text" name="host" value="<?php echo $host; ?>" style="width: 150"></td>
			</tr>

			<tr>
				<td width="50%" align="right">Database name:&nbsp;&nbsp;</td>
				<td width="50%" align="left" nowrap><input type="text" name="db" value="<?php echo $db; ?>" style="width: 150"></td>
			</tr>

			<?php if($no_db) { ?>
			<tr>
				<td width="50%" align="right"><i>Should I try to create this database</i>?&nbsp;&nbsp;</td>
				<td width="50%" align="left" nowrap><input type="checkbox" name="db_create" value=1 <?php if($db_create) echo "checked"; ?>></td>
			</tr>
			<?php } ?>

			<tr>
				<td width="50%" align="right">Username:&nbsp;&nbsp;</td>
				<td width="50%" align="left"><input type="text" name="user" value="<?php echo $user; ?>" style="width: 150"></td>
			</tr>

			<tr>
				<td width="50%" align="right">Password:&nbsp;&nbsp;</td>
				<td width="50%" align="left"><input type="password"  name="pass" value="<?php echo $pass; ?>" style="width: 150"></td>
			</tr>

			<tr>
				<td width="50%" align="right">ZoomStats Table Prefix:&nbsp;&nbsp;</td>
				<td width="50%" align="left"><input type="text" name="prefix" value="<?php echo $prefix; ?>" style="width: 150"></td>
			</tr>

			<tr>
				<td colspan=2 align=center><br><input type="submit"  name="update" value="   UPDATE   "></td>
			</tr>

		</table>
	</table>

	<?php
}


function do_switch($db) {

	if($db->api_errno() == 1046)
		$db->error_id = 'db_cant_select';

	switch($db->error_id) {

		case 'db_no_host':
			fecho( "	<font color='red'>Host `{$db->db_host}' not found. ({$db->api_name} said: <i>{$db->error_data['message']}</i>)</font>\n");
			break;

		case 'db_cant_connect':
			fecho( "	<font color='red'>Can't connect to `{$db->db_host}' as `{$db->db_username}'. ({$db->api_name} said: <i>{$db->error_data['message']}</i>)</font>\n");
			break;

		case 'db_cant_select':

			fecho( "	<font color='red'>Database `{$db->db_database}' does not exist. ({$db->api_name} said: <i>{$db->error_data['message']}</i>)</font>\n");

			$GLOBALS['no_db'] = True;
			if(!$GLOBALS['first_time'] and $_POST['db_create'] == 1) {
				create_db($db);
				$GLOBALS['just_created_db'] = True;
			}

			break;

		default:
			fecho( "	<font color='red'>Unknown error occured. ({$db->api_name} said: <i>{$db->error_data['message']}</i>)</font>\n");
			break;
	}
}


function test_connection() {

	fecho( "<h1>\nTesting database connection...</h1>");

	Global $db;
	$db->error_quiet = True;
	$db->query('show_tables');
	$db->error_quiet = False;
	if($db->error_id) {
		do_switch($db);

		if(!$GLOBALS['just_created_db'])
			Return False;
	}

	$version = $db->query('server_version');
	Return $version[0]['SERVER_VERSION'];
}



function find_zoomstats() {

	fecho( "<h1>\nLooking for previous ZoomStats installations...</h1>\n");

	Global $db;

	$return = Array(
		 'found'    => False
		,'db_ok'    => False
		,'version'  => ''
		,'tables'   => Array()
		,'settings' => Array()
	);

	$return['found'] = False;
	$db->error_quiet = True;
	$db_tables       = $db->query('show_tables', Array('db'=>$db->db_database));

	if($db->error_id) {
		do_switch($db);
	}

	else {

		$db->error_quiet = False;

		$return['db_ok'] = True;
		fecho( "	<font color='green'>Database located!</font>\n");

		#r((array)$db);

		foreach($db_tables as $table) {
			$table = split($db->table_prefix, $table[key($table)], 2);
			if(sizeof($table) == 2)
				$return['tables'][$table[1]] = $table[1];
		}

		if(empty($db_tables)) {
			fecho( "	Found no tables, thus no installation\n");
			Return $return;
		}

		fecho( "	Found some tables. Checking integrity...\n");

		if(isset($return['tables']['settings'])) {
			// settings retrieval function goes here
			fecho("	Investigating ZoomStats version...\n");

			$settings = Array();

			foreach($db->query('load_settings') as $varname=>$vardata) {
				$settings[$varname] = $vardata['VARDATA'];
			}

			if(empty($settings) or !(isset($settings['version']) and ereg("^[0-9]\.[0-9]{0,2}\.[0-9]{0,2}$", $settings['version']))) {
				fecho("	<font color='red'>Missing important data from `{$db->table_prefix}settings'</font>\n");
				Return $return;
			}

			foreach(unserialize($settings['tables']) as $required_table) {
				if(!isset($return['tables'][$required_table])) {
					$missing_tables[] = $required_table;
				}
			}

			if(isset($missing_tables)) {
				fecho("	<font color='red'>Table(s) `<b>{$db->table_prefix}" . implode("</b>', `<b>{$db->table_prefix}", $missing_tables) . "</b>' are missing! Reinstall required!</font>\n");
				Return $return;
			}

			$return['version']  = $settings['version'];
			$return['settings'] = $settings;
			$return['found']    = True;
		}

		else {

			if(isset($return['tables']['hits'])) {
				fecho("	<font color='red'>`{$db->table_prefix}settings' table is missing. Assuming v1.0.1</font>\n");
				$return['version'] = '1.0.1';
				$return['found']   = True;
			}
			else {
				fecho("	<font color='red'>Found only `<b>{$db->table_prefix}" . implode("</b>', `<b>{$db->table_prefix}", $return['tables']) . "</b>' table(s). Looks quite useless. Unable to upgrade. <b>(If doable, fix ZoomStats DB manualy)</b></font>\n");
			}
		}
	}

	Return $return;
}


function create_db($db) {
	fecho("<pre>");
	fecho("<b>	Trying to create `{$db->db_database}' database ...</b>\n");

	$db->error_quiet = True;
	$db->query('create_db', Array('db'=>$db->db_database));
	$db->error_quiet = False;

	if($db->error_id) {

		$extra_mess = "(Try creating it manually: `mysqladmin create {$db->db_database}')";
		switch($db->error_data['errno']) {
			case 1007:
				fecho("	<font color='red'>Database is already there. </font>\n");
				$extra_mess = '';
				break;
			default:
				fecho("	<font color='red'>Unknown error occured. ({$db->api_name} said: <i>{$db->error_data['message']}</i>)</font>\n");
				break;
		}
		fecho("	<font color='red'><b>Failed to create the database `{$db->db_database}'. </b>$extra_mess</font>\n");
	}

	else {
		fecho("	<font color='green'><b>Database `{$db->db_database}' created</b></font>\n");
		$GLOBALS['no_db'] = False;
	}

	fecho("</pre>");
}

$GLOBALS['first_time'] = empty($_POST)? True : False;

if(!$first_time) {
	$GLOBALS['_ZOOMSTATS']['db']['type']         = $_POST['type'];
	$GLOBALS['_ZOOMSTATS']['db']['host']         = $_POST['host'];
	$GLOBALS['_ZOOMSTATS']['db']['database']     = $_POST['db'];
	$GLOBALS['_ZOOMSTATS']['db']['username']     = $_POST['user'];
	$GLOBALS['_ZOOMSTATS']['db']['password']     = $_POST['pass'];
	$GLOBALS['_ZOOMSTATS']['db']['table_prefix'] = $_POST['prefix'];
}
else
	$defaults = $GLOBALS['_ZOOMSTATS']['db'];


$_POST['db_create']                              = $first_time? 1 : @$_POST['db_create'];

$db = db();
$db->db_store['install'] = $_ZOOMSTATS['path']['install'] . '/mysql.php';
$db->table_prefix        = 'zoomstats_';

?>

<center><h1>ZoomStats Installation</h1></center>
<hr>

<?php

fecho("<pre>\n");
$conn   = test_connection();


if($conn) {
	fecho("	<font color='green'><b>Successfully connected to {$db_types[$GLOBALS['_ZOOMSTATS']['db']['type']]} v$conn</b></font>\n");
}
else {
	fecho("	<font color='red'><b>Connection failed. Please check database details.</b></font>\n");
	db_form(
		 $GLOBALS['_ZOOMSTATS']['db']['type']
		,$db_types
		,$db->db_host
		,$db->db_database
		,$db->db_username
		,$db->db_password
		,$db->table_prefix
		,@$_POST['db_create']
		,$no_db
	);
}



if($conn) {
	$lookup  = find_zoomstats();
	$propose = Array();

	if($lookup['found']) {
		fecho("	<font color='green'><b>Found ZoomStats v{$lookup['version']}.</b></font>\n");

		if(version_compare($lookup['version'], $_ZOOMSTATS['version'], '=='))
			$propose['install'] = 'Re-install';
		else
			$propose['upgrade'] = True;
	}

	else if (!isset($_POST['go'])) {
		fecho("	<font color='red'><b>ZoomStats not found! " . ($first_time? " (using default configuration.)" : '') . "</b></font>\n");
		fecho("</pre>");

		if(!$GLOBALS['just_created_db']) {
			db_form(
				 $GLOBALS['_ZOOMSTATS']['db']['type']
				,Array('mysql'=>'MySQL', 'pgsql'=>'PostgreSQL', 'oracle'=>'Oracle 8/9')
				,$db->db_host
				,$db->db_database
				,$db->db_username
				,$db->db_password
				,$db->table_prefix
				,@$_POST['db_create']
				,$no_db
			);

			?>
			<p><i><font color='red'>
			If you have are upgrading ZoomStats make sure to provide the same details as previousely used!<br>
			</font><i>
			<?php
		}

			$propose['install'] = 'Install';
	}

	if(!isset($_POST['go'])) {

		if(!empty($propose)) {

			?>
			</pre>
			<form method="POST" action="<?php echo $_SERVER['PHP_SELF']; ?>">
			<center>

			<?php if(isset($propose['upgrade'])) { ?>

			<input type="submit" name="go[upgrade]" value="<?php
			echo "\nUpgrade to ZoomStats v{$_ZOOMSTATS['version']}\n&nbsp;";
			?>" style="width:100%">
			<?php } ?>

			<?php if(isset($propose['install'])) { ?>

			<input type="submit" name="go[install]" value="<?php

			echo "\n{$propose['install']} ZoomStats v{$_ZOOMSTATS['version']}\n&nbsp;";
			?>" style="width:100%">
			<?php

			if(!empty($lookup['tables']))
				echo "(Tables `<b>{$db->table_prefix}" . implode("</b>', `<b>{$db->table_prefix}", $lookup['tables']) . "</b>' will be destroyed!)";

			?>
			<?php } ?>


			<input type="hidden" name="type"   value="<?php echo $GLOBALS['_ZOOMSTATS']['db']['type']; ?>">
			<input type="hidden" name="host"   value="<?php echo $db->db_host; ?>">
			<input type="hidden" name="db"     value="<?php echo $db->db_database; ?>">
			<input type="hidden" name="user"   value="<?php echo $db->db_username; ?>">
			<input type="hidden" name="pass"   value="<?php echo $db->db_password; ?>">
			<input type="hidden" name="prefix" value="<?php echo $db->table_prefix; ?>">

			</form>
			<pre>
			<?php
		}
	}

	else {

		$mode = isset($_POST['go']['install'])? 'install' : (isset($_POST['go']['upgrade'])? 'upgrade' : 'unknown');

		echo "<pre>";

		switch($mode) {
			case 'install':
				echo "<h1>\nInstalling ...</h1>\n";

				if(!empty($lookup['tables'])) {
					foreach($lookup['tables'] as $table) {
						fecho("	droping `{$db->table_prefix}$table'...\n");
						$db->query('drop', Array('table'=>$table));
					}
				}

				$actions = Array(
					 'create_settings' => Array(
						 'desc' => 'Creating SETTINGS'
						,'data' => Array()
					)

					,'insert_settings' => Array(
						 'desc'  => 'Inserting SETTINGS'
						,'data'  => Array()
						,'batch' => Array(
							 'version'   => Array('varname' =>'version'  , 'vardata'=>$_ZOOMSTATS['version'])
							,'installed' => Array('varname' =>'installed', 'vardata'=>time())
							,'tables'    => Array('varname' =>'tables'   , 'vardata'=>serialize(Array('hits', 'settings', 'users', 'users_permissions')))
						)
					)

					,'create_users' => Array(
						 'desc' => 'Creating USERS'
						,'data' => Array()
					)

					,'create_users_permissions' => Array(
						 'desc' => 'Creating USER PERMISSIONS'
						,'data' => Array()
					)

					,'insert_users' => Array(
						 'desc' => 'Inserting default user'
						,'data' => Array()
					)

					,'insert_users_permissions' => Array(
						 'desc' => ''
						,'data' => Array()
					)

					,'create_hits' => Array(
						 'desc' => 'Creating HITS table'
						,'data' => Array()
					)

				);


				db_execute($actions);

				echo "<h1>\nPost Install Check...</h1>\n";

				$lookup  = find_zoomstats();

				fecho("	<font color='green'><b>Found ZoomStats v{$lookup['version']}.</b></font>\n");

				if($lookup['found']) {
					$installed = True;
					echo "<h1>\n<font color='green'>Congratulations!";
					echo "<br>You successfully installed ZoomStats v{$lookup['version']}!";
					echo "</h1></font>\n";
				}

				else {
					echo "<h1>\n<font color='red'>Oh My God! Something went deadly wrong!...</font></h1>";
					echo "\nWhether try repeating the installation or visit www.zoomstats.org for bugs and help\n";
				}

				break;
			case 'upgrade':
				echo "<h1>Upgrading...</h1>";

				$updates = Array(
					 '1.0.1-1.0.2' => Array(

						 'create_settings' => Array(
							 'desc' => 'Creating SETTINGS'
							,'data' => Array()
						)

						,'insert_settings' => Array(
							 'desc'  => 'Inserting SETTINGS'
							,'data'  => Array()
							,'batch' => Array(
								 'version'   => Array('varname' =>'version'  , 'vardata'=>$_ZOOMSTATS['version'])
								,'installed' => Array('varname' =>'installed', 'vardata'=>time())
								,'tables'    => Array('varname' =>'tables'   , 'vardata'=>serialize(Array('hits', 'settings', 'users', 'users_permissions')))
							)
						)
					)
				);

				$start_version = $lookup['version'];

				foreach($updates as $branches=>$actions) {

					list($migrate_from, $migrate_to) = explode('-', $branches);

					if(!version_compare($lookup['version'], $migrate_from, '=='))
						continue;

					$lookup['version'] = $migrate_to;
					db_execute($actions);
				}

				if(version_compare($lookup['version'], $_ZOOMSTATS['version'], '==')) {
					$installed = True;
					echo "<h1>\n<font color='green'>Congratulations! You successfully upgrated ZoomStats";
					echo "<br>from v{$start_version} to v{$_ZOOMSTATS['version']}!";
					echo "</h1></font>\n";
				}

				else {
					echo "<h1>\n<font color='red'>Oh My God! Something went deadly wrong!...</font></h1>";
					echo "\nWhether try repeating the installation or visit www.zoomstats.org for bugs and help\n";
				}

				break;
			case 'unknown':
				echo "<h1>Say again?.... Unrecognized action.</h1>";
				Exit;
				break;
		}
	}
}


if($installed) {
	if($defaults != $GLOBALS['_ZOOMSTATS']['db']) {
?>

<hr>
<h1>
<font color='red'>Config File</font></h1>
Please edit <b>`config_db.php'</b> file in the root directory of ZoomStats installation
(full server path: <b>`<?php echo dirname(dirname(__FILE__)) . '/config_db.php';?>'</b>).

<p>Add the following (<b>replacing anything</b> it currently contains):

<table border=1 style="border-collapse: collapse" bordercolor="#111111" cellpadding=5 bgcolor="#ECECFF"><tr><td>
<?php highlight_string("<?php

//  Database Type
\$_ZOOMSTATS['db']['type']         = '{$GLOBALS['_ZOOMSTATS']['db']['type']}';

//  Host
\$_ZOOMSTATS['db']['host']         = '{$db->db_host}';

//  Username
\$_ZOOMSTATS['db']['username']     = '{$db->db_username}';

//  Password
\$_ZOOMSTATS['db']['password']     = '{$db->db_password}';

//  Database Name
\$_ZOOMSTATS['db']['database']     = '{$db->db_database}';

//  Database Name
\$_ZOOMSTATS['db']['table_prefix'] = '{$db->table_prefix}';
 
?>");?>
</td></tr></table>

<font color='red'>IMPORTANT NOTE: There must be <b>NO SPACES OR NEWLINES</b> before <b>`&lt;php'</b> or after <b>`?&gt;'</b>!</font>

<font color='red'>IMPORTANT NOTE 2: <b>DELETE OR PROTECT `installer' DICTORY!!</b> (full server path: <b>`<?php echo dirname(dirname(__FILE__)) . '/installer';?>'</b>). <br>Otherwise, visitors will have the way to reinstall your ZoomStats!</font>

<?php } ?>

<hr>
<h1>
<a href="../"><font color='green'>Start using ZoomStats v<?php echo $_ZOOMSTATS['version']; ?> now!</font></a></h1>
<h3>Username: "admin", Password: "admin".
Don't forget to change your Username and Password at your first login!</h3>

<hr>
<h1>
<font color='red'>Thanks for installing ZoomStats v<?php echo $_ZOOMSTATS['version']; ?>!</font></h1>
<h3>Comments, suggestion, bugs and/or interests are welcome!</h3>


<hr>
<i><h3>
ZoomStats Team
<a href="http://www.zoomstats.org">ZoomStats.org</a>
</h3></i>

<?php
}
?>

