<?php

/*                                                       www.zoomstats.org
   +----------------------------------------------------------------------+
   | ZoomStats  ::  Web Traffic Analyzer                                  |
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2003 ZoomStats Group                              |
   +----------------------------------------------------------------------+
   | This file is protected by General Public License (GPL)               |
   |                                                                      |
   | GPL license does not restrict you from the usage, modification and   |
   | and redistribuition of this code. It, however, requires you to       |
   | always maintain each and every copyright (c) notice untouched.       |
   |                                                                      |
   | For full license please see the file LICENSE.TXT in this             |
   | distribution. The up-to-date version of this license is also         |
   | available online at: www.zoomstats.org/license                       |
   +----------------------------------------------------------------------+

     Project Home:
   +----------------------------------------------------------------------+
     Official Site:    http://www.zoomstats.org
     Development Area: http://sf.net/projects/zoomstats
     Latest Release:   http://sf.net/project/showfiles.php?group_id=59637
     CVS Repository:   http://sf.net/cvs/?group_id=59637
     Support & Bugs:   http://sf.net/tracker/?group_id=59637

   +----------------------------------------------------------------------+
   |                        !!! BE INTERACTIVE !!!                        |
   |                                                                      |
   | Please send us your patches, improvements, bugs, requests or just    |
   | say thanks at the links above.                                       |
   +----------------------------------------------------------------------+

     File:             $RCSfile: mysql.php,v $
   +----------------------------------------------------------------------+
     Version:          $Revision: 1.6 $
     Last Updated:     $Date: 2003/06/27 02:24:51 $
     Last Author:      $Author: s-maxim $

     Maintainers:
   +----------------------------------------------------------------------+
     Maxim Maletsky    (s-maxim)
     maxim at php dot net     http://www.maxim.cx 

     Description:
   +----------------------------------------------------------------------+
     MySQL Installing Storage

 */

// Allow this file only from index.php
if(!defined('zoomstats')) {
	header("Location: ../../../../index.php" . ($_SERVER['QUERY_STRING']? "?{$_SERVER['QUERY_STRING']}" : ''));
	Exit;
}


switch($alias) {

	case 'server_version':
		$query['type']          = 'select';
		$query['sql']           = "SELECT VERSION() AS SERVER_VERSION";
		break;

	case 'show_tables':
		$query['type']          = 'select';
		$query['sql']           = "SHOW TABLES";
		break;

	case 'create_db':
		$query['type']          = 'create';
		$query['sql']           = "CREATE DATABASE $db";
		break;

	case 'drop':
		$query['type']          = 'select';
		$query['sql']           = "DROP TABLE {$table_prefix}$table";
		break;


	case 'create_settings':

		$query['type']          = 'create';
		$query['sql']           = "

			CREATE TABLE {$table_prefix}settings (
				 s_name              VARCHAR   ( 32)  NOT NULL PRIMARY KEY
				,s_data              TEXT
				,s_last_update       TIMESTAMP

				,INDEX ix_last_update  (s_last_update)
			)
				COMMENT = 'ZoomStats Settings'

		";
		break;


	case 'insert_settings':

		$query['type']          = 'insert';
		$query['sql']           = "

				INSERT INTO
					{$table_prefix}settings
				VALUES(
					 '$varname'
					,'$vardata'
					,NOW()
				)
		";

		break;


	case 'create_users':

		$query['type']          = 'create';
		$query['sql']           = "

			CREATE TABLE {$table_prefix}users (
				 u_id                MEDIUMINT   (4)  UNSIGNED auto_increment  NOT NULL PRIMARY KEY
				,u_user              VARCHAR   ( 32)  NOT NULL
				,u_pass              VARCHAR   (100)  NOT NULL  default ''
				,u_name              VARCHAR   ( 30)  NOT NULL  default ''
				,u_surname           VARCHAR   ( 30)  NOT NULL  default ''
				,u_created           DATETIME         NOT NULL  default 0
				,u_last_login        DATETIME         NOT NULL  default 0
				,u_last_update       DATETIME         NOT NULL  default 0

				,UNIQUE INDEX uk_user      (u_user)
				,UNIQUE INDEX uk_user_pass (u_user, u_pass)

			)
				COMMENT = 'ZoomStats Users'

		";
		break;


	case 'insert_users':

		$query['type']          = 'insert';
		$query['sql']           = "

				INSERT INTO
					{$table_prefix}users
				VALUES(
					 1
					,'admin'
					,PASSWORD('admin')
					,'Administrator'
					,''
					,NOW()
					,NOW()
					,NOW()
				)

		";
		break;



	case 'create_users_permissions':

		$query['type']          = 'create';
		$query['sql']           = "

			CREATE TABLE {$table_prefix}users_permissions (
				 up_id               MEDIUMINT   (4)  UNSIGNED      NOT NULL PRIMARY KEY
				,up_last_update      DATETIME                       NOT NULL  default 0
				,up_stats            tinyint     (3)  UNSIGNED      NOT NULL  default 0
				,up_users            tinyint     (3)  UNSIGNED      NOT NULL  default 0
			)
			COMMENT = 'ZoomStats User Permissions'

		";
		break;


	case 'insert_users_permissions':

		$query['type']          = 'insert';
		$query['sql']           = "

			INSERT INTO
				{$table_prefix}users_permissions
			VALUES(
				 1
				,NOW()
				,255
				,255
			)

		";
		break;



	case 'create_hits':

		$query['type']          = 'create';
		$query['sql']           = "

			CREATE TABLE {$table_prefix}hits (
				 hit_id              MEDIUMINT (  8)  UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY
				,hit_sid             CHAR      ( 32)  NOT NULL DEFAULT '00000000000000000000000000000000'
				,hit_time            TIMESTAMP ( 14)  NOT NULL
				,hit_host            VARCHAR   ( 31)  NOT NULL
				,hit_port            SMALLINT  (  5)  NOT NULL
				,hit_protocol        VARCHAR   ( 10)  NOT NULL
				,hit_query           VARCHAR   (255)
				,hit_uri             VARCHAR   (255)  NOT NULL
				,hit_method          VARCHAR   (  8)  NOT NULL
				,hit_connection      VARCHAR   ( 20)  NOT NULL
				,hit_encoding        VARCHAR   (255)
				,hit_language        VARCHAR   (255)
				,hit_agent           VARCHAR   (255)
				,hit_referer         VARCHAR   (255)
				,hit_remote_ip       VARCHAR   ( 20)  NOT NULL
				,hit_remote_host     VARCHAR   (255)
			)
				COMMENT = 'Hits Database'

		";
		break;



	// Dummy default
	default:
		break;
}


?>