<?php

/*                                                       www.zoomstats.org
   +----------------------------------------------------------------------+
   | ZoomStats  ::  Web Traffic Analyzer                                  |
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2003 ZoomStats Group                              |
   +----------------------------------------------------------------------+
   | This file is protected by General Public License (GPL)               |
   |                                                                      |
   | GPL license does not restrict you from the usage, modification and   |
   | and redistribuition of this code. It, however, requires you to       |
   | always maintain each and every copyright (c) notice untouched.       |
   |                                                                      |
   | For full license please see the file LICENSE.TXT in this             |
   | distribution. The up-to-date version of this license is also         |
   | available online at: www.zoomstats.org/license                       |
   +----------------------------------------------------------------------+

     Project Home:
   +----------------------------------------------------------------------+
     Official Site:    http://www.zoomstats.org
     Development Area: http://sf.net/projects/zoomstats
     Latest Release:   http://sf.net/project/showfiles.php?group_id=59637
     CVS Repository:   http://sf.net/cvs/?group_id=59637
     Support & Bugs:   http://sf.net/tracker/?group_id=59637

   +----------------------------------------------------------------------+
   |                        !!! BE INTERACTIVE !!!                        |
   |                                                                      |
   | Please send us your patches, improvements, bugs, requests or just    |
   | say thanks at the links above.                                       |
   +----------------------------------------------------------------------+

     File:             $RCSfile: mysql.php,v $
   +----------------------------------------------------------------------+
     Version:          $Revision: 1.6 $
     Last Updated:     $Date: 2003/06/26 19:09:36 $
     Last Author:      $Author: s-maxim $

     Maintainers:
   +----------------------------------------------------------------------+
     Maxim Maletsky    (s-maxim)
     maxim at php dot net     http://www.maxim.cx 

     Description:
   +----------------------------------------------------------------------+
     MySQL Query Storage

     It is very important that you read this:

     Consult shared.sql.php for usage of this file.

 */

// Allow this file only from index.php
if(!defined('zoomstats')) {
	header("Location: ../../../../index.php" . ($_SERVER['QUERY_STRING']? "?{$_SERVER['QUERY_STRING']}" : ''));
	Exit;
}

switch($alias) {

	/*   Query:            load_config
	   +------------------------------------------------------------------+
	     Author:           Maxim Maletsky (maxim at php dot net)
	     Description:      A test query.
	                       Retrieves Configuration
	   +------------------------------------------------------------------+
	*/

	case 'load_settings':

		$query['type']          = 'select';
		$query['key']           = 'VARNAME';
		$query['sql']           = "

			SELECT
				 s_name AS VARNAME
				,s_data AS VARDATA
			FROM
				{$table_prefix}settings

		";
		break;



	/*   Query:            view
	   +------------------------------------------------------------------+
	     Author:           Maxim Maletsky (maxim at php dot net)
	     Description:      A test query.
	                       Retrieves last hits
	   +------------------------------------------------------------------+
	*/

	case 'all':

		$query['type']          = 'select';
		$query['to_string']     = True;
		$query['sql']           = "

			SELECT
				count(*)
			FROM
				zoomstats_hits
			;

		";
		break;



	/*   Query:            view
	   +------------------------------------------------------------------+
	     Author:           Maxim Maletsky (maxim at php dot net)
	     Description:      A test query.
	                       Retrieves last hits
	   +------------------------------------------------------------------+
	*/

	case 'view':

		$query['type']  = 'select';
		$query['key']   = 'hit_id';
		$query['sql']   = "

			SELECT
				*
			FROM
				zoomstats_hits
			ORDER
				BY hit_id DESC
			LIMIT
				$from, $to
			;

		";
		break;


	case 'authenticate':
		$query['type']          = 'select';
		$query['sql']           = "
			SELECT

				 U.U_ID                               AS ID
				,U.U_USER                             AS USER
				,U.U_NAME                             AS NAME
				,U.U_SURNAME                          AS SURNAME
				,U.U_CREATED                          AS CREATED
				,U.U_LAST_LOGIN                       AS LAST_LOGIN
				,U.U_LAST_UPDATE                      AS LAST_UPDATE

				,UP.UP_LAST_UPDATE                    AS PERM_LAST_UPDATE
				,UP.UP_STATS                          AS UP_STATS
				,UP.UP_USERS                          AS UP_USERS

			FROM
				zoomstats_users                       AS U
				LEFT JOIN zoomstats_users_permissions AS UP ON U.U_ID = UP.UP_ID

			WHERE
				    U.U_USER  = '$user'
				and U.U_PASS  = PASSWORD('$pass')
		";

		break;


	case 'list_users':
		$query['type']          = 'select';
		$query['sql']           = "
			SELECT

				 U.U_ID                               AS ID
				,U.U_USER                             AS USER
				,U.U_NAME                             AS NAME
				,U.U_SURNAME                          AS SURNAME
				,U.U_CREATED                          AS CREATED
				,U.U_LAST_LOGIN                       AS LAST_LOGIN
				,U.U_LAST_UPDATE                      AS LAST_UPDATE

				,UP.UP_LAST_UPDATE                    AS PERM_LAST_UPDATE
				,UP.UP_STATS                          AS UP_STATS
				,UP.UP_USERS                          AS UP_USERS

			FROM
				zoomstats_users                       AS U
				LEFT JOIN zoomstats_users_permissions AS UP ON U.U_ID = UP.UP_ID
		";

		break;


	case 'drop_user':
		$query['type']          = 'drop';
		$query['sql']           = "
			DELETE FROM
				zoomstats_users
			WHERE
				U_ID = $id
		";
		break;


	case 'drop_user_perm':
		$query['type']          = 'drop';
		$query['sql']           = "
			DELETE FROM
				zoomstats_users_permissions
			WHERE
				UP_ID = $id
		";
		break;

	case 'load_user':
		$query['type']          = 'select';
		$query['sql']           = "
			SELECT

				 U.U_ID                               AS ID
				,U.U_USER                             AS USER
				,U.U_NAME                             AS NAME
				,U.U_SURNAME                          AS SURNAME
				,U.U_CREATED                          AS CREATED
				,U.U_LAST_LOGIN                       AS LAST_LOGIN
				,U.U_LAST_UPDATE                      AS LAST_UPDATE

				,UP.UP_LAST_UPDATE                    AS PERM_LAST_UPDATE
				,UP.UP_STATS                          AS UP_STATS
				,UP.UP_USERS                          AS UP_USERS

			FROM
				zoomstats_users                       AS U
				LEFT JOIN zoomstats_users_permissions AS UP ON U.U_ID = UP.UP_ID

			WHERE
				    U.U_ID    = '$id'
		";

		break;



	case 'save_user':
		$query['type']          = $statement;
		$query['sql']           = "

			" . ($statement == 'update'? "UPDATE" : "INSERT INTO") . "
				 zoomstats_users
			SET

				" . ($statement == 'insert'? "
					 U_CREATED     = NOW(),
				" : "") . "
					 U_LAST_UPDATE = NOW()
					,U_USER        = '$USER'
					" . (($statement == 'insert' or $PASSWORD)? ",U_PASS     = password('$PASSWORD')" : "") . "
					,U_NAME        = '$NAME'
					,U_SURNAME     = '$SURNAME'
		";

			if($statement == 'update') {
				$query['sql']          .= "
				WHERE
					    U_ID = $id
				";
			}

		break;


	case 'save_user_permissions':
		$query['type']          = $statement;
		$query['sql']           = "

			" . ($statement == 'update'? "UPDATE" : "INSERT INTO") . "
				 zoomstats_users_permissions
			SET

					" . ($statement == 'insert'? "
						 UP_ID       = $id,
					" : "") . "

					 UP_LAST_UPDATE  = NOW()
					,UP_STATS        = {$mode['STATS']}
					,UP_USERS        = {$mode['USERS']}

		";
			if($statement == 'update') {
				$query['sql']          .= "
				WHERE
					    UP_ID = $id
				";
			}

		break;

	// Dummy default
	default:
		break;
}


?>