<?php

/*                                                       www.zoomstats.org
   +----------------------------------------------------------------------+
   | ZoomStats  ::  Web Traffic Analyzer                                  |
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2003 ZoomStats Group                              |
   +----------------------------------------------------------------------+
   | This file is protected by General Public License (GPL)               |
   |                                                                      |
   | GPL license does not restrict you from the usage, modification and   |
   | and redistribuition of this code. It, however, requires you to       |
   | always maintain each and every copyright (c) notice untouched.       |
   |                                                                      |
   | For full license please see the file LICENSE.TXT in this             |
   | distribution. The up-to-date version of this license is also         |
   | available online at: www.zoomstats.org/license                       |
   +----------------------------------------------------------------------+

     Project Home:
   +----------------------------------------------------------------------+
     Official Site:    http://www.zoomstats.org
     Development Area: http://sf.net/projects/zoomstats
     Latest Release:   http://sf.net/project/showfiles.php?group_id=59637
     CVS Repository:   http://sf.net/cvs/?group_id=59637
     Support & Bugs:   http://sf.net/tracker/?group_id=59637

   +----------------------------------------------------------------------+
   |                       !!! BE INTERACTIVE !!!                         |
   |                                                                      |
   | Please send us your patches, improvements, bugs, requests or just    |
   | say thanks at the links above.                                       |
   +----------------------------------------------------------------------+

     File:             $RCSfile: record.php,v $
   +----------------------------------------------------------------------+
     Version:          $Revision: 1.2 $
     Last Updated:     $Date: 2003/06/25 18:44:24 $
     Last Author:      $Author: s-maxim $

     Maintainers:
   +----------------------------------------------------------------------+
     Maxim Maletsky    (s-maxim)
     maxim@php.net     http://www.maxim.cx
     
     Description:
   +----------------------------------------------------------------------+
     PHP Module to include in all pages that wish to record a visitor.
*/



// Define ZoomStats.
// Prevents theoretical security risks

if(!defined('zoomstats'))
	define('zoomstats', True, True);

// Include config file
include_once dirname(__FILE__) . '/' . 'config_db.php';

if(!isset($_SERVER))
	include_once dirname(__FILE__) . '/' . 'config.php';


// From here we should go debugging data collected.
// As, for instance, we can try figuring out the proxy and real IP.

// Unique ID. (something we will think of setting later on)
if(isset($_COOKIE['zoomstats_sid']))
	$this->hit['zoomstats_sid'] = $_COOKIE['zoomstats_sid'];
else {
	// Create unique hash
	$token = md5(uniqid(rand(),1));

	// Expire in 33 years :-)
	setcookie('zoomstats_sid', $token, time()*2);
}

$zoomstats_hit['host']             = trim(@$_SERVER['HTTP_HOST']);                 // Current Host
//$zoomstats_hit['port']           =  trim($_SERVER['REMOTE_PORT']);               // Port
$zoomstats_hit['port']             =  0;                                           // Port
$zoomstats_hit['protocol']         = trim(@$_SERVER['SERVER_PROTOCOL']);           // Protocol
$zoomstats_hit['query']            = trim(@$_SERVER['QUERY_STRING']);              // Query
$zoomstats_hit['uri']              = trim(@$_SERVER['REQUEST_URI']);               // Full request
$zoomstats_hit['method']           = trim(@$_SERVER['REQUEST_METHOD']);            // Method
$zoomstats_hit['connection']       = trim(@$_SERVER['HTTP_CONNECTION']);           // Connection type
$zoomstats_hit['encoding']         = trim(@$_SERVER['HTTP_ACCEPT_ENCODING']);      // Compression Encoding
$zoomstats_hit['language']         = trim(@$_SERVER['HTTP_ACCEPT_LANGUAGE']);      // Browser Language
$zoomstats_hit['agent']            = trim(@$_SERVER['HTTP_USER_AGENT']);           // User Agent (Browser)
$zoomstats_hit['referer']          = trim(@$_SERVER['HTTP_REFERER']);              // Referer
$zoomstats_hit['remote_ip']        = trim(@$_SERVER['REMOTE_ADDR']);               // Remote IP address
$zoomstats_hit['remote_host']      = @gethostbyaddr($zoomstats_hit['remote_ip']);  // Remote host

/*
echo "<pre>\n";
print_r($zoomstats_hit);
*/

// Connect to MySQL Server
if($zoomstats_db_conn = @mysql_connect($_ZOOMSTATS['db']['host'], $_ZOOMSTATS['db']['username'], $_ZOOMSTATS['db']['password'])) {
// Hook onto a MySQL database
	if(@mysql_select_db($_ZOOMSTATS['db']['database'], $zoomstats_db_conn)) {

		// Prepare query
		$zoomstats_db_query = "
			INSERT INTO
				zoomstats_hits
			SET
				 hit_sid          = '{$zoomstats_hit['zoomstats_sid']}'
				,hit_time         = NOW()
				,hit_host         = '{$zoomstats_hit['host']}'
				,hit_port         = '{$zoomstats_hit['port']}'
				,hit_protocol     = '{$zoomstats_hit['protocol']}'
				,hit_query        = '{$zoomstats_hit['query']}'
				,hit_uri          = '{$zoomstats_hit['uri']}'
				,hit_method       = '{$zoomstats_hit['method']}'
				,hit_connection   = '{$zoomstats_hit['connection']}'
				,hit_encoding     = '{$zoomstats_hit['encoding']}'
				,hit_language     = '{$zoomstats_hit['language']}'
				,hit_agent        = '{$zoomstats_hit['agent']}'
				,hit_referer      = '{$zoomstats_hit['referer']}'
				,hit_remote_ip    = '{$zoomstats_hit['remote_ip']}'
				,hit_remote_host  = '{$zoomstats_hit['remote_host']}'
		";

		// Execute query
		$zoomstats_db_stmt = @mysql_query($zoomstats_db_query, $zoomstats_db_conn);

		// free up the memory
		@mysql_free_result($zoomstats_db_stmt);

		// Close database connection
		@mysql_close($zoomstats_db_conn);
	}
	else
		echo('no db');

}
else
	echo('no connection');


?>