<?php

/*                                                       www.zoomstats.org
   +----------------------------------------------------------------------+
   | ZoomStats  ::  Web Traffic Analyzer                                  |
   +----------------------------------------------------------------------+
   | Copyright (c) 2002-2003 ZoomStats Group                              |
   +----------------------------------------------------------------------+
   | This file is protected by General Public License (GPL)               |
   |                                                                      |
   | GPL license does not restrict you from the usage, modification and   |
   | and redistribuition of this code. It, however, requires you to       |
   | always maintain each and every copyright (c) notice untouched.       |
   |                                                                      |
   | For full license please see the file LICENSE.TXT in this             |
   | distribution. The up-to-date version of this license is also         |
   | available online at: www.zoomstats.org/license                       |
   +----------------------------------------------------------------------+

     Project Home:
   +----------------------------------------------------------------------+
     Official Site:    http://www.zoomstats.org
     Development Area: http://sf.net/projects/zoomstats
     Latest Release:   http://sf.net/project/showfiles.php?group_id=59637
     CVS Repository:   http://sf.net/cvs/?group_id=59637
     Support & Bugs:   http://sf.net/tracker/?group_id=59637

   +----------------------------------------------------------------------+
   |                       !!! BE INTERACTIVE !!!                         |
   |                                                                      |
   | Please send us your patches, improvements, bugs, requests or just    |
   | say thanks at the links above.                                       |
   +----------------------------------------------------------------------+

     File:             $RCSfile: users_edit.php,v $
   +----------------------------------------------------------------------+
     Version:          $Revision: 1.4 $
     Last Updated:     $Date: 2003/06/25 18:05:44 $
     Last Author:      $Author: s-maxim $

     Maintainers:
   +----------------------------------------------------------------------+
     Maxim Maletsky    (s-maxim)
     maxim at php dot net     http://www.maxim.cx 

     Description:
   +----------------------------------------------------------------------+
     Edit User

 */


// Prevents theoretical security risks
if(!defined('zoomstats'))
	define('zoomstats', True, True);

include 'libs/functions.php';
include 'config.php';

$db      = db();
$section = 'USERS';

$m = $_SESSION['auth']['mode'];


if(!$m['USERS'][WRITE]) {
	$auth_obj->login('You don\'t have enough priviledge to edit the users.', $section);
}

if(isset($_POST['cancel'])) {
	header("Location: users.php");
	exit;
}

$id           = @$_GET['id'];
$statement    = isset($_GET['id'])? 'update' : 'insert';


if(isset($_POST['delete'])) {

	if(!$m['USERS'][DELETE]) {
		$auth_obj->login('You don\'t have enough priviledge to delete users.', $section);
	}

	if(RUNNING_DEMO and $id==2) {
		die('You cannot perform this action in Demo mode - please create another user, logout and login to play with it');
	}
	else {
		$db->query('drop_user'     , Array('id'=>$id));
		$db->query('drop_user_perm', Array('id'=>$id));
	}

	header("Location: users.php");
	exit;
}


else if(isset($_POST['save'])) {

	$dati                          = $_POST;
	$dati['id']                    = $id;
	$dati['statement']             = $statement;

	if($dati['PASSWORD'] != $dati['PASSWORD2']) {
		echo "Passwords do not match";
		exit;
	}

	foreach($m as $k=>$v) {
		$dati['mode'][$k] = isset($dati['mode'][$k])? array_sum($dati['mode'][$k]) : 0;
	}

	#r($dati);

	if(RUNNING_DEMO and $id==2) {
		die('You cannot perform this action in Demo mode - please create another user, logout and login to play with it');
	}
	else {
		$db->query('save_user', $dati);

		if($statement == 'insert'){
			$id = $dati['id'] = $db->api_last_id();
		}

		$db->query('save_user_permissions', $dati);
	}


/*
	$db->query('drop_utente_dai_gruppi' , Array('id_utente'=>$id));

	foreach($dati['GRUPPI'] as $gruppo)
		if($gruppo)
			$db->query('salva_utente_gruppi', Array('utente'=>$id, 'gruppo'=>$gruppo));
*/

	if($statement == 'insert'){
		header("Location: users.php");
		exit;
	}

	$statement = 'update';
}

if($statement == "update"){
	$user_data = $db->query('load_user', Array('id'=>$id));
	foreach($user_data[0] as $key=>$data) 
		$template_assign['data'][$key] = $user_data[0][$key];

	//$smarty->assign($data);
}


/*
// Gruppi
$gruppi = $db->query('elenco_gruppi');

$smarty_assign['gruppi'][0] = '';
foreach($gruppi as $key=>$data) {
	$smarty_assign['gruppi'][$data['ID']] = $data['GRUPPO'];
}

$smarty_assign['gruppi_selected'] = Array();
if($id) {
	$gruppi = $db->query('utente_carica_gruppi', Array('id'=>$id));
	foreach($gruppi as $data) {
		$smarty_assign['gruppi_selected'][] = $data['ID_GRUPPO'];
	}
}
*/
$template_assign['action']    = 'users_edit.php' . ($statement == 'update'? "?id=" . $id : '');
$template_assign['m']         = $m;
$template_assign['data']['m'] = filter_auth_modes(@$user_data[0], AUTH_FILTER_KEY);

$template_assign['auth_conf'] = $auth_conf;
$template_assign['left_size'] = 20;
$template_assign['head_size'] = (100 - $template_assign['left_size']) / sizeof($auth_conf);

template('users_edit', $template_assign);

#r($template_assign);

?>